<?php

/**
 * inf_cierre_persuasivo actions.
 *
 * @package    cobro_coactivo
 * @subpackage inf_cierre_persuasivo
 * @author     ManuelEnriqueParedesLopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_cierre_persuasivoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_CIERRE_PERSUASIVO',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_PROCESO_COACTIVO',
        'CBR_TIPO_DOCUMENTO',
        'CBR_ABOGADO_ULT_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_CIERRE_PERSUASIVO'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_PROCESO_COACTIVO, LEFT' =>
        array(
            'id_remision_titulo' => 'CBR_CIERRE_PERSUASIVO'
        ),
        'CBR_TIPO_DOCUMENTO, LEFT' =>
        array(
            'id_tipo_documento' => 'CBR_CIERRE_PERSUASIVO'
        ),
        'CBR_ABOGADO_ULT_V,LEFT'=>
        array(
            'id_remision_titulo' => 'CBR_CIERRE_PERSUASIVO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_CIERRE_PERSUASIVO' =>
        array(
            'id_cierre_persuasivo' => 'id_cierre_persuasivo',
            'id_remision_titulo' => 'id_remision_titulo',
            'estado' => 'estado',
            'fecha_cierre' => 'fecha_cierre',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto',
            'cierre' => 'cierre',
            'id_tipo_documento' => 'id_tipo_documento',
            'num_doc_sop' => 'num_doc_sop',
            'fecha_doc' => 'fecha_doc',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado_remision',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral'
        ),
        'CBR_PROCESO_COACTIVO' =>
        array(
            'id_remision_titulo' => 'proceso_coactivo'
        ),
        'CBR_TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'tipo_documento_soporte'
        ),
        'CBR_ABOGADO_ULT_V' =>
        array(
            'razon_soc' => 'abogado'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'fecha_cierre'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_CIERRE_PERSUASIVO' =>
        array(
            'id_cierre_persuasivo,a' => array('!=' => array(-1)),
            'id_cierre_persuasivo,b' => array('=' => array('id_cierre_persuasivo')),
            'id_remision_titulo' => array('=' => array('id_remision_titulo')),
            'fecha_log' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_ABOGADO_ULT_V'=>
        array(
            'id_abogado' => array('=' => array('id_abogado')),
            'num_doc' => array('IN' => array('num_doc'))
        ),
        'CBR_REMISION_TITULO'=>
        array(
            'numero_remision' => array('=' => array('numero_remision')),
            'cod_titulo' => array('=' => array('cod_titulo')),
            'id_par' => array('=' => array('id_par'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $query_qualifier = 'DISTINCT'; //Para eliminar filas repetidas
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_cierre_persuasivo'; //identificador de la tabla
    protected $id_names = array('id_cierre_persuasivo'); //llave primaria
    protected $field_names = array('id_remision_titulo', 'estado', 'fecha_cierre', 'observaciones', 'adjunto',
        'cierre', 'id_tipo_documento', 'num_doc_sop', 'fecha_doc', 'usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_CIERRE_PERSUASIVO'; //tabla en la cual se aplican los cambios 
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_cierre_persuasivo'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

           
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            
        }

        //accion update
        if ($Action == "UPDATE") {

          
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
